unit upyramide;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, StdCtrls,
  ExtCtrls, Buttons, Grids;

type

  { Tfpyramide }

  Tfpyramide = class(TForm)
    BitBtn1: TBitBtn;
    b_berechnen: TButton;
    e_hoehe: TEdit;
    e_kante: TEdit;
    Image1: TImage;
    Label1: TLabel;
    t_ausgabe: TStringGrid;
    procedure b_berechnenClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { private declarations }
  public
    { public declarations }
  end;

var
  fpyramide: Tfpyramide;

implementation

{$R *.lfm}

{ Tfpyramide }

procedure Tfpyramide.FormCreate(Sender: TObject);
VAR spalte, zeile : BYTE;
begin
  FOR spalte:= 0 TO 1 DO BEGIN
                          t_ausgabe.ColWidths[spalte]:=110;
                         END;
  FOR zeile:= 0 TO 5 DO BEGIN
                          t_ausgabe.RowHeights[zeile]:=30;
                         END;

  t_ausgabe.cells[0,0] := 'Gesucht:';
  t_ausgabe.cells[1,0] := 'Lösung:';

  t_ausgabe.cells[0,1] := 'Grundfläche';
  t_ausgabe.cells[0,2] := 'Seitenfläche';
  t_ausgabe.cells[0,3] := 'Mantelfläche';
  t_ausgabe.cells[0,4] := 'Oberfläche';
  t_ausgabe.cells[0,5] := 'Volumen';

end;

procedure Tfpyramide.b_berechnenClick(Sender: TObject);
VAR kante,hoehe : SINGLE;
    grundflaeche,seitenflaeche,mantelflaeche,oberflaeche,volumen : SINGLE;

  FUNCTION AG(a:SINGLE):SINGLE;
  BEGIN
   AG := a*a;
  END;

  FUNCTION ASeite(a,h:SINGLE):SINGLE;
  VAR ha : SINGLE;
  BEGIN
   ha := SQRT(SQR(h) + SQR(a/2));
   ASeite := 0.5 * a * ha;
  END;

  FUNCTION AM(a,h:SINGLE):SINGLE;
  BEGIN
   AM := 4 * ASeite(a,h);
  END;

  FUNCTION AO(a,h:SINGLE):SINGLE;
  BEGIN
   AO := AG(a) + AM(a,h);
  END;

  FUNCTION V(a,h:SINGLE):SINGLE;
  BEGIN
   V := 1/3 * AG(a) * h;
  END;

begin
  //Wertuebergabe
  kante := STRTOFLOAT(e_kante.text);
  hoehe := STRTOFLOAT(e_hoehe.text);

  //Verarbeitung
  grundflaeche := AG(kante);
  seitenflaeche := ASeite(kante,hoehe);
  mantelflaeche := AM(kante,hoehe);
  oberflaeche := AO(kante,hoehe);
  volumen := V(kante,hoehe);

  //Ausgabe
  t_ausgabe.cells[1,1]:=FLOATTOSTRF(grundflaeche,ffnumber,8,2);
  t_ausgabe.cells[1,2]:=FLOATTOSTRF(seitenflaeche,ffnumber,8,2);
  t_ausgabe.cells[1,3]:=FLOATTOSTRF(mantelflaeche,ffnumber,8,2);
  t_ausgabe.cells[1,4]:=FLOATTOSTRF(oberflaeche,ffnumber,8,2);
  t_ausgabe.cells[1,5]:=FLOATTOSTRF(volumen,ffnumber,8,2);

end;

end.

